#DEFINE N_MAXPOINTS		40
#DEFINE N_COLORBRUSH	0xFFF5F5F5 && 0xFFF5F5F5 / 0xFF87CEFA / 0xFF000000
#DEFINE WM_ERASEBKGND 0x0014
#DEFINE WM_PAINT 0x000F

*CLEAR ALL
*RELEASE ALL  
IF !('_gdiplus' $ LOWER(SET("Classlib")))
	SET CLASSLIB TO (HOME()+ 'ffc\_gdiplus.vcx') ADDITIVE 
ENDIF 
IF TYPE('goFrm') = 'U'
	PUBLIC goFrm as Form
	goFrm = NEWOBJECT('frmDrawSin')
	IF VARTYPE(goFrm) # 'O'
		RELEASE goFrm
		RETURN .F.
	ENDIF
ENDIF
IF TYPE('goFrm') = 'O' AND !ISNULL(goFrm)
	goFrm.Show()
	IF VERSION(2) = 0
		IF goFrm.ShowWindow <> 2 
			WITH _SCREEN
				IF !.Visible
					.Visible = .T.
				ENDIF
			ENDWITH	
		ENDIF		 
		READ EVENTS
		CLEAR DLLS 
	ENDIF  
ENDIF		


DEFINE CLASS frmBase AS form
	AutoCenter = .T.
	Caption = "GDI+ test (base form)"
	Name = "frmBase"
	RealHwnd = 0

	PROCEDURE Unload
		IF TYPE('goFrm') # 'U'
			RELEASE goFrm
		ENDIF
		IF VERSION(2) = 0
			CLEAR EVENTS
		ENDIF  
	ENDPROC


	PROCEDURE Init
		DECLARE LONG BeginPaint IN User32 ;
			LONG HWND,;
			STRING @lpPaint
		DECLARE LONG EndPaint IN User32 ;
			LONG HWND,;
			STRING @lpPaint
		WITH thisForm
			.AddObject('Gpgraphics1','_gdiplus.Gpgraphics') 
			IF TYPE('ThisForm.Gpgraphics1') # 'O' OR ISNULL(.Gpgraphics1)
				RETURN .F.
			ENDIF
			.Gpgraphics1.Name = PROPER(.Gpgraphics1.Name)
			* SYS(2327, SYS(2325, SYS(2326,.hwnd))) == GetWindow(.hwnd, GW_CHILD)	
			.RealHwnd = IIF(.ShowWindow = 2, SYS(2327, SYS(2325, SYS(2326, .hWnd))), .hWnd)
			IF .RealHwnd = 0
				RETURN .F.
			ENDIF
			=BINDEVENT(.RealHwnd, WM_ERASEBKGND, this, 'WinEventHandler')
			=BINDEVENT(.RealHwnd, WM_PAINT, this, 'WinEventHandler')
		ENDWITH
	ENDPROC
	
	
	PROCEDURE Destroy
		UNBINDEVENTS(0)
		WITH thisForm
			IF TYPE('ThisForm.Gpgraphics1') = 'O' AND !ISNULL(.Gpgraphics1)
				.RemoveObject(.Gpgraphics1.Name) 
			ENDIF
		ENDWITH
	ENDPROC
	

	PROCEDURE Resize()
		this.MyPaint()
	ENDPROC
	

	PROCEDURE MyPaint
		this.Paint() 
	ENDPROC


	PROCEDURE WinEventHandler
		LPARAMETERS HWND, msg, wParam, LPARAM
		DO CASE
			CASE msg = WM_PAINT
				LOCAL lvPaintStruct
				lvPaintStruct = SPACE(56)
				=BeginPaint(HWND, @lvPaintStruct)
				this.MyPaint()
				=EndPaint(HWND, @lvPaintStruct)
			CASE msg = WM_ERASEBKGND
				RETURN 1
			OTHERWISE
		ENDCASE
	ENDPROC

ENDDEFINE


DEFINE CLASS frmDrawSin AS frmBase
	Height = 304
	Width = 576
	BorderStyle = 3
	Caption = "GDI+ test SIN() function"
	HalfHeightCaption = .T.
	Name = "frmDrawSin"
	*ShowWindow = 2

	PROCEDURE drawAxises
		LOCAL loLineColor as Object 
		loLineColor = NEWOBJECT( ;
		  '_gdiplus.GpColor','',null, 0, 0, 255)
		LOCAL loPen as Object 
		loPen = NEWOBJECT('_gdiplus.GpPen')
		loPen.Create(loLineColor, 2)
		LOCAL loBrush as Object 
		loBrush = NEWOBJECT('_gdiplus.GpSolidBrush')
		loBrush.Create(N_COLORBRUSH)
		WITH thisForm
			.Gpgraphics1.FillRectangle(loBrush;
				,0, 0, .Width, .Height)
			.Gpgraphics1.DrawLine(loPen ;
				,0, .Height/2, .Width, .Height/2)
			.Gpgraphics1.DrawLine(loPen ;
				,.Width/2, 0, .Width/2, .Height)
		ENDWITH
	ENDPROC


	PROCEDURE drawSin
		LOCAL loLineColor as Object 
		loLineColor = NEWOBJECT( ;
		  '_gdiplus.GpColor','',null, 255, 0, 0)
		LOCAL loPen as Object 
		loPen = NEWOBJECT('_gdiplus.GpPen')
		loPen.Create(loLineColor, 1)

		LOCAL lnXmin as Number, lnXmax as Number;
			,lnArgLen as Number, lnStep as Number;
			,lnXL as Number, lnXR as Number; 
			,lnFL as Number, lnFR as Number;
			,lnXk as Number, lnX0 as Number;
			,lnYk as Number, lnY0 as Number

		lnXmax = PI()
		lnXmin = -lnXmax
		lnArgLen = lnXmax - lnXmin
		lnStep = lnArgLen/N_MAXPOINTS
		lnXL = lnXmin
		lnFL = SIN(lnXL)
		lnXR = lnXL + lnStep

		WITH thisForm
			lnX0 = lnXmax 	   
			lnXk = .Width/lnArgLen
			lnY0 = -1.0
			lnYk = -.Height/2.0 
			DO WHILE (lnXR <= lnXmax)
				lnFR = SIN(lnXR)
				.Gpgraphics1.DrawLine(loPen ;
					,(lnXL + lnX0)*lnXk, (lnFL + lnY0)*lnYk;
					,(lnXR + lnX0)*lnXk, (lnFR + lnY0)*lnYk)
				lnXL = lnXR
				lnFL = lnFR
				lnXR = lnXL + lnStep
			ENDDO
		ENDWITH
	ENDPROC
	
	
	PROCEDURE MyPaint
		WITH thisform
			IF TYPE('ThisForm.Gpgraphics1') = 'O' AND !ISNULL(.Gpgraphics1)
				.Gpgraphics1.CreateFromHWND(.RealHwnd)
				.Gpgraphics1.Clear(0xFFFFFFFF)
				.drawAxises()
				.drawSin()
			ENDIF	
		ENDWITH	 
	ENDPROC
	

ENDDEFINE